<?php
/**
 * @package Sj K2 Listing
 * @version 1.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2012 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 *
 */
defined('_JEXEC') or die;

class K2ListingReader extends SjReader {

	function getList(& $params) {
		$items = array();
		$user 		=&	JFactory::getUser();
		$app 		=&	JFactory::getApplication();
		$db   		=&	JFactory::getDBO();
		
		jimport ( 'joomla.utilities.date' );
		
		$date       = new JDate ( );
		$now        = $date->toMySQL ();
		$nullDate	=	$db->getNullDate();
		$noauth		= !	$app->getParams()->get('show_noauth');
		$aid = $user->get ( 'aid', 0 );
		$aid = 1;
		
		if(!isset($params['source']) || empty($params['source'])){
			$this->errors = "No selected or all selected is unpublished.";
			return array();
		}
		$arraycatid = ($params['source']);
		if (!is_null ($arraycatid)){
			if (!is_array($arraycatid)) {
				$arraycatid = array($arraycatid);
			}
			foreach ($arraycatid as $key=> $value) {
				$query = "SELECT distinct(a.id),a.*,u.name as creater, cr.rating_sum/cr.rating_count as rating, c.name as categoryname, c.id as catid, c.id as categoryid, c.alias as categoryalias, c.params as categoryparams, cc.commentcount as commentcount".
                                        " FROM #__k2_items as a".
                                        " LEFT JOIN #__k2_categories c ON c.id = a.catid" .
                                        " LEFT JOIN #__k2_rating as cr ON a.id = cr.itemid".
                                        " LEFT JOIN #__users AS u ON a.created_by = u.id".
                                        " LEFT JOIN (select cm.itemid  as id, count(cm.id) as commentcount from #__k2_comments as cm
                                        where cm.published=1 group by cm.itemid) as cc on a.id = cc.id";           
				$query .= " WHERE a.published = 1"
				. " AND a.access IN(".implode(',', $user->authorisedLevels()).")"
				. " AND a.trash = 0"
				. " AND c.published = 1"
				. " AND c.access IN(".implode(',', $user->authorisedLevels()).")"
				//. " AND c.id =IN (".$stringcatid.")"
				. " AND c.id = '{$value}'"
				. " AND c.trash = 0 " ;
				if( $params['featured'] == 0 ){
					$query.= " AND a.featured != 1";
				} elseif( $params['featured'] == 1 ) {
					$query.= " AND a.featured = 1";
				}

				switch ($params['sort_order_field'])
				{
					case 'created': $ordering = 'a.created DESC';
					break;
					case 'modified': $ordering = 'a.modified DESC';
					break;
					case 'ordering': $ordering = 'a.ordering';
					break;
					case 'title': $ordering = 'a.title';
					break;
					case 'mostpopular': $ordering = 'a.hits DESC';
					break;
					case 'leastpopular': $ordering = 'a.hits ASC';
					break;
					case 'random': $ordering = 'RAND()';
					break;
					default:       $ordering = 'a.created';
					break;
				}
				$query .=  ' ORDER BY ' . $ordering;
				$query .=  $params['limit_articles'] ? ' LIMIT ' . $params['limit_articles'] : '';
				$db->setQuery($query);
				$a = $db->loadObjectlist();
				if(!empty($a)){
					$items[] = $a;
				}    //var_dump($items); die("abc");
			}
		}

		if(!empty($items)){
			require_once ( JPath::clean(JPATH_SITE.'/components/com_k2/helpers/route.php') );
			$imgResizeConfig = array(
                        'background' => $params['item_thumbnail_background'],
                        'thumbnail_mode' => $params['item_thumbnail_mode']);							
			YTools::getImageResizerHelper($imgResizeConfig);
			foreach ($items as $key=>$value){
				$article = array();
				foreach ($value as $item) {
					$temp = array();
					$item->introtext = trim($item->introtext);
					if (file_exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'src'.DS.md5("Image".$item->id).'.jpg')){
						$item->image = implode(array(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'src'.DS.md5("Image".$item->id).'.jpg'));
						YTools::extractImages($item->introtext);
					} else {
						$item->article_image = YTools::extractImages($item->introtext);
						$item->image = (empty( $item->article_image) || !file_exists($item->article_image[0]) ) ? 'modules/mod_sj_k2_listing/assets/images/nophoto.gif' : $item->article_image[0]  ;
					}
					if($item->access <= $aid ) {
						$item->category_link = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urldecode($item->categoryalias))));
						$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
					}
					if($params['cutStr_style_article']== 1){
						$temp['article_content'] = $item->introtext;
					}else{
						$temp['article_content'] = strip_tags($item->introtext);
					}
					$temp['article_id'] = $item->id;
					$temp['article_sub_title'] = $item->title;
					$temp['creater'] = $item->creater;
					$temp['article_image'] = $item->image;
					//$temp['article_content'] = $item->introtext;
					$temp['article_link'] = $item->link;
					$temp['article_hits'] = $item->hits;
					$temp['article_author']=$item->creater;
					$temp['category_link'] = $item->category_link;
					$temp['category_sub_title']= $item->categoryname;
					$temp['date']= JHtml::_('date', $item->created, JText::_('DATE_FORMAT_LC3'));
					$temp['catid']=$item->catid;
					$article[] = $temp;
				}
				$items[$key] = $article;
			}
				
			return $items;
		}
	}

}

?>
